(***********************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which typically
will have the same name as this file except ending in ".nb" instead of
".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent to
using the Evaluate Initialiation Cells menu command in the front end.

DO NOT EDIT THIS FILE.  This entire file is regenerated automatically 
each time the parent Notebook file is saved in the Mathematica front end.
Any changes you make to this file will be overwritten.
***********************************************************************)

(* $Id: BlockMatrix.m,v 3.0 1996/11/23 *)


(*:Version: Mathematica 3.0 *)

(*:Name: BlockMatrix *)

(*:Title: Block Matrix Manipulation Package *)


(*:Legal: Copyright (c) 1990-1996, David A. Belsley *)

(*:Summary: Kronecker Product, Vec, Adjoin, BlockDiagonal, BlockMatrix *)

(*:Keywords: Econometrics, simultaneous systems, *)

(*:Requirements: No special system requirements. *)

(*:Warning: Experimental Package *)

(*:Sources: Econometrics texts, Principles of Econometrics, Wiley (1971) by H. Theil, and Conditioning Diagnostics: Collinearity and Weak Data in Regression Wiley (1991) by David A. Belsley. *)



BeginPackage["BlockMatrix`"]

KroneckerProduct::usage = 
"KroneckerProduct[A_?MatrixQ, B_?MatrixQ] forms the
Kronecker product of two matrices."

Vec::usage = 
"Vec[A_?MatrixQ] forms a vector by stacking the columns
of A."

Adjoin::usage = 
"Adjoin[r__] forms the block matrix [A B...G] from the
sequence of row-commensurate matrices r."

BlockDiagonalMatrix::usage = 
"BlockDiagonalMatrix[r__] forms a block diagonal matrix
from the sequence of matrices r."

BlockMatrix::usage = 
"BlockMatrix[D_] forms a block matrix from a matrix of
commensurate matrices D."



Begin["`private`"]


KroneckerProduct[a_?MatrixQ, b_?MatrixQ] :=
	Partition[Flatten[Map[Transpose,Outer[Times,a,b],1]],
		Dimensions[a][[2]]*Dimensions[b][[2]]]
		
		
Vec[a_?MatrixQ] := Flatten[Transpose[a]]


Adjoin[r__] := Transpose[Flatten[Map[Join,Map[Transpose,
		{r}]],1]]/;Apply[Equal,Map[Dimensions[#][[1]]&,{r}]]
		
		
BlockDiagonalMatrix[r__] :=
	Block[{mat = {r},i,ra,ca,rb,cb},
		If[Length[mat]==1,Return[mat[[1]]],
			For[i=2,i<=Length[mat],i++,
				{ra,ca} = Dimensions[mat[[1]]];
				{rb,cb} = Dimensions[mat[[i]]];
				mat[[1]]=Adjoin[Join[mat[[1]],Table[0.0,{rb},{ca}]],
					Join[Table[0.0,{ra},{cb}],mat[[i]]] ]
			]
		];
		Return[mat[[1]]];
	]/;TrueQ[Scan[If[!MatrixQ[{r}[[#]]],Return[False]]&,
		Range[1,Length[{r}]] ] == Null]
	
	
BlockMatrix[d_] := Apply[Join,Map[Apply[Adjoin,d[[#]]]&,
	Range[Length[d]]]]/;Depth[d]>3 && Scan[If[!MatrixQ[#],
	Return[False]]&,d,{2}]==Null
	


End[]

EndPackage[]